# frozen_string_literal: true

require "pseudo_legal_move_tablebase/shogi"
require "pseudo_legal_move_tablebase/xiangqi99"

module Nichugi
  class Tablebase
    attr_reader :db

    def initialize
      @db = shogi.merge(xiangqi99)
    end

    def possibilities(piece:, source:, target:)
      Array(@db.dig(piece, source, target))
    end

    def inspect
      "<Nichugi::Tablebase #{@db.keys.sort.join(' ')}>"
    end

    private

    def shogi
      ::PseudoLegalMoveTablebase::Shogi::DB
    end

    def xiangqi99
      ::PseudoLegalMoveTablebase::Xiangqi99::DB
    end
  end
end
